apemanstore
==========

<!---
This file is generated by ape-tmpl. Do not update manually.
--->

<!-- Badge Start -->
<a name="badges"></a>

[![Build Status][bd_travis_shield_url]][bd_travis_url]
[![Code Climate][bd_codeclimate_shield_url]][bd_codeclimate_url]
[![Code Coverage][bd_codeclimate_coverage_shield_url]][bd_codeclimate_url]
[![npm Version][bd_npm_shield_url]][bd_npm_url]

[bd_repo_url]: https://github.com/apeman-labo/apemanstore
[bd_travis_url]: http://travis-ci.org/apeman-labo/apemanstore
[bd_travis_shield_url]: http://img.shields.io/travis/apeman-labo/apemanstore.svg?style=flat
[bd_license_url]: https://github.com/apeman-labo/apemanstore/blob/master/LICENSE
[bd_codeclimate_url]: http://codeclimate.com/github/apeman-labo/apemanstore
[bd_codeclimate_shield_url]: http://img.shields.io/codeclimate/github/apeman-labo/apemanstore.svg?style=flat
[bd_codeclimate_coverage_shield_url]: http://img.shields.io/codeclimate/coverage/github/apeman-labo/apemanstore.svg?style=flat
[bd_gemnasium_url]: https://gemnasium.com/apeman-labo/apemanstore
[bd_gemnasium_shield_url]: https://gemnasium.com/apeman-labo/apemanstore.svg
[bd_npm_url]: http://www.npmjs.org/package/apemanstore
[bd_npm_shield_url]: http://img.shields.io/npm/v/apemanstore.svg?style=flat
[bd_bower_badge_url]: https://img.shields.io/bower/v/apemanstore.svg?style=flat

<!-- Badge End -->


<!-- Description Start -->
<a name="description"></a>

apeman flavored redux store.

<!-- Description End -->


<!-- Overview Start -->
<a name="overview"></a>



<!-- Overview End -->


<!-- Sections Start -->
<a name="sections"></a>

<!-- Section from "doc/guides/01.Installation.md.hbs" Start -->

<a name="section-doc-guides-01-installation-md"></a>
Installation
-----

```bash
$ npm install apemanstore --save
```


<!-- Section from "doc/guides/01.Installation.md.hbs" End -->

<!-- Section from "doc/guides/02.Usage.md.hbs" Start -->

<a name="section-doc-guides-02-usage-md"></a>
Usage
---------

```javascript
"use strict";

const apemanstore = require('apemanstore');

apemanstore.define(
    (store, action) => {
        /*...*/
    }
).assign(
    {
        /*...*/
    }
);

const SignStore = apemanstore.define(
    // Define  reducer
    (state, action) => {
        switch (action.type) {
            case 'SET':
                return action.signed;
            case 'DEL':
                return null;
            default:
                return state;
        }
    }
).assign(
    // Assign custom props.
    {
        setSign(signed) {
            let s = this;
            s.dispatch({
                type: 'SET',
                signed: signed
            });
            return s;
        },
        getSign() {
            let s = this;
            return s.getState() || null;
        },
        delSign() {
            let s = this;
            s.dispatch({type: 'DEL'});
            return s;
        }
    }
);


let store = new SignStore({});

// Subscribe change
store.subscribe(() => {
    let sign = store.getSign();
    console.log(sign);
});

store.setSign({id: 1});

```


<!-- Section from "doc/guides/02.Usage.md.hbs" End -->


<!-- Sections Start -->


<!-- LICENSE Start -->
<a name="license"></a>

License
-------
This software is released under the [MIT License](https://github.com/apeman-labo/apemanstore/blob/master/LICENSE).

<!-- LICENSE End -->


<!-- Links Start -->
<a name="links"></a>

Links
------

+ [apeman](https://github.com/apeman-labo/apeman)

<!-- Links End -->
