/**
 * Apeman flavoured redux store.
 * @class Apemanstore
 */

"use strict";

const redux = require('redux');

/** @lends Apemanstore */
class Apemanstore {
    constructor(reducer, config) {
        let s = this;
        if (typeof reducer === 'object') {
            reducer = redux.combineReducers(reducer);
        }
        let _reduxStore = redux.createStore(reducer);
        s.__proto__ = _reduxStore;
        Object.assign(s, {_reduxStore}, Apemanstore.methods, config);
    }
}

Apemanstore.methods = {
    /**
     * Get a state.
     * @param {string} [name] - Name of state property
     * @returns {*}
     */
    getState(name) {
        let s = this,
            state = s._reduxStore.getState();
        if (arguments.length === 0) {
            return state;
        }
        if (!state.hasOwnProperty(name)) {
            throw new Error(`Unknown state name ${name}`);
        }
        return state[name];
    }
};


module.exports = Apemanstore;