/**
 * Test case for apemanstore.
 * Runs with mocha.
 */
"use strict";

const Apemanstore = require('../lib/apemanstore.js'),
    assert = require('assert');

describe('apemanstore', () => {

    before((done) => {
        done();
    });

    after((done) => {
        done();
    });


    it('Apemanstore', (done) => {
        let store = new Apemanstore((state, action)=> {
            return action;
        }, {});
        assert.ok(store);
        done();
    });

    it('Combined store', (done) => {
        let store = new Apemanstore({
            foo(state, action){
                return 'foo-' + action.value;
            },
            bar(state, action){
                return 'bar-' + action.value;
            }
        });
        assert.ok(store);
        store.dispatch({type: 'foo', value: 1});
        store.dispatch({type: 'bar', value: 2});
        let unsubscribe = store.subscribe(() => {

        });
        unsubscribe();
        let state = store.getState();
        assert.deepEqual(state, {foo: 'foo-2', bar: 'bar-2'});
        assert.equal(store.getState('foo'), 'foo-2');
        assert.equal(store.getState('bar'), 'bar-2');
        done();
    });
});

