/**
 * Test case for define.
 * Runs with mocha.
 */
"use strict";

const define = require('../lib/define.js'),
    assert = require('assert');

describe('define', () => {

    before((done) => {
        done();
    });

    after((done) => {
        done();
    });


    it('Define', (done) => {
        let Store = define((state, action) => {
            switch (action.type) {
                case 'hoge':
                    return action.val;
                default:
                    return action;
            }
        }).assign({
            getFoo(){
                return 'foo';
            }
        }, {
            getBaz(){
                return 'baz';
            }
        });
        let instance = new Store({
            getBar(){
                return 'bar';
            }
        });
        assert.ok(instance);
        assert.equal(instance.getFoo(), 'foo');
        assert.equal(instance.getBaz(), 'baz');
        assert.equal(instance.getBar(), 'bar');
        instance.subscribe(() => {
            let v = instance.getState();
            assert.equal(v, 'hoge');
        });
        instance.dispatch({
            "type": "hoge",
            "val": "hoge"
        });

        let singleton = Store.singleton;
        assert.ok(singleton);
        assert.equal(singleton.getFoo(), 'foo');
        done();
    });
});

